use std::collections::HashSet;

use crate::stingray_sdk::LuaRef;

#[derive(Debug)]
pub(crate) struct RPC {
    listeners: HashSet<LuaRef>,
}

impl RPC {
    pub fn new() -> Self {
        Self {
            listeners: Default::default(),
        }
    }

    pub(crate) fn add_listener(&mut self, fn_ref: LuaRef) {
        self.listeners.insert(fn_ref);
    }

    pub(crate) fn listeners(&self) -> impl Iterator<Item = &LuaRef> {
        self.listeners.iter()
    }
}
